; 

      include \masm32\include\masm32rt.inc
      include DlgMacroFile\dialogs.inc

      MainDlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 
      enable_common_controls PROTO

    .data?
        hInstance dd ?

    .code

; 
UseCommonControls = 0		; 1=full code enabled and called, 0=no enable_common_controls in code
call InitCommonControlsEx	; this will never be called, but [url=http://www.masm32.com/board/index.php?topic=15932.msg131804#msg131804]as Alex rightly stated[/url], it is sufficient to make this code work

start:
if UseCommonControls
	invoke enable_common_controls
endif
	mov hInstance, FUNC(GetModuleHandle,NULL)
	call main
	invoke ExitProcess, eax

; 

main proc

    Dialog "Centered Images", \             ; caption
           "MS Sans Serif",8, \             ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            3, \                            ; number of controls
            50,50,150,80, \                 ; x y co-ordinates
            1024                            ; memory buffer size

    DlgBitmapEx 5,5,0,65,65,999
    DlgIconEx 10,90,10,30,30,998
    DlgButton "Cancel",WS_TABSTOP,85,45,50,12,IDCANCEL

    CallModalDialog hInstance,0,MainDlgProc,NULL

    ret

main endp

; 

MainDlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    .if uMsg == WM_INITDIALOG
      invoke SendMessage,hWin,WM_SETICON,1,rv(LoadIcon,hInstance,10)

    .elseif uMsg == WM_COMMAND
      .if wParam == IDCANCEL
        jmp quit_dialog
      .endif

    .elseif uMsg == WM_CLOSE
      quit_dialog:
       invoke EndDialog,hWin,0

    .endif

    xor eax, eax
    ret

MainDlgProc endp

; 
if UseCommonControls
enable_common_controls proc

    LOCAL icce:INITCOMMONCONTROLSEX

  ; --------------------------------------
  ; comment out the styles you don't need.
  ; --------------------------------------
    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
    xor eax, eax                                            ; set EAX to zero
    or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
    or eax, ICC_BAR_CLASSES                                 ; comment out the rest
    or eax, ICC_COOL_CLASSES
    or eax, ICC_DATE_CLASSES
    or eax, ICC_HOTKEY_CLASS
    or eax, ICC_INTERNET_CLASSES
    or eax, ICC_LISTVIEW_CLASSES
    or eax, ICC_PAGESCROLLER_CLASS
    or eax, ICC_PROGRESS_CLASS
    or eax, ICC_TAB_CLASSES
    or eax, ICC_TREEVIEW_CLASSES
    or eax, ICC_UPDOWN_CLASS
    or eax, ICC_USEREX_CLASSES
    or eax, ICC_WIN95_CLASSES
    mov icce.dwICC, eax
    invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library
  ; --------------------------------------

    ret

enable_common_controls endp
endif

; 

end start
OPT_Tmp2Asm	1
